package cn.com.infosec.asn1.pkcs;

import cn.com.infosec.asn1.ASN1EncodableVector;
import cn.com.infosec.asn1.ASN1Sequence;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DERObjectIdentifier;
import cn.com.infosec.asn1.DERSequence;
import cn.com.infosec.asn1.x509.AlgorithmIdentifier;
import java.util.Enumeration;

/** @deprecated */
public class PBES2Algorithms extends AlgorithmIdentifier implements PKCSObjectIdentifiers {
   private DERObjectIdentifier objectId;
   private KeyDerivationFunc func;
   private EncryptionScheme scheme;

   public PBES2Algorithms(ASN1Sequence obj) {
      super(obj);
      Enumeration obj1;
      this.objectId = (DERObjectIdentifier)(obj1 = obj.getObjects()).nextElement();
      ASN1Sequence var2;
      DERObjectIdentifier var3;
      if ((var2 = (ASN1Sequence)(obj1 = ((ASN1Sequence)obj1.nextElement()).getObjects()).nextElement()).getObjectAt(0).equals(var3 = PKCSObjectIdentifiers.id_PBKDF2)) {
         this.func = new KeyDerivationFunc(var3, PBKDF2Params.getInstance(var2.getObjectAt(1)));
      } else {
         KeyDerivationFunc var5;
         var5 = new KeyDerivationFunc.<init>(var2);
         this.func = var5;
      }

      this.scheme = new EncryptionScheme((ASN1Sequence)obj1.nextElement());
   }

   public DERObjectIdentifier getObjectId() {
      return this.objectId;
   }

   public KeyDerivationFunc getKeyDerivationFunc() {
      return this.func;
   }

   public EncryptionScheme getEncryptionScheme() {
      return this.scheme;
   }

   public DERObject getDERObject() {
      ASN1EncodableVector var1;
      ASN1EncodableVector var10000 = var1 = new ASN1EncodableVector;
      var10000.<init>();
      ASN1EncodableVector var2;
      ASN1EncodableVector var10001 = var2 = new ASN1EncodableVector;
      var2.<init>();
      var1.add(this.objectId);
      var2.add(this.func);
      var10001.add(this.scheme);
      var10000.add(new DERSequence(var2));
      return new DERSequence(var1);
   }
}
